      SUBROUTINE CALC(DEST,IM,IP)
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      DIMENSION DEST(NQUMAX)
      COMPLEX*16 Z,ZZ,GAMMA
      REAL*8 R(2),RR(2)
      COMMON/PRTCTL/IPRT,IFREQ
      EQUIVALENCE (Z,R(1)),(ZZ,RR(1))
C The device NONE has no S parameters but the code was written
C with parameters for them. Any changes are numerical errors
C clear the variables so they look good in case they might become
C printed. These variables are never used. 
      R(1)=0
      R(2)=0
      GAM_S11(1)=Z
      GAM_S22(1)=Z
      R(1)=1
      GAM_S12(1)=Z
C Step through the measured data. Compute reflection coefficient 
C and insertion loss.
      IF(IP.EQ.1)WRITE(*,608)
  608 FORMAT(/,
     &'Dev.      Z(mea)     Zerr     Loss     NF(mea)    NFerr     VSWR
     &      NF      NFloss')   


      SQSUM=0
      NQU=0
      DO 100 I=1,NEXP
      PLOSS=0
C The calkit load is our definition of "50 ohms" GAMMA, the reflection
C coefficient is zero
      R(1)=0      
      R(2)=0
      IF(IDUT(I,1).EQ.1)GOTO 1000
C There are DUTs. Look through them and compute gamma.
      DO 110 J=1,6
      K=IDUT(I,J)
      IF(K.EQ.0)GOTO 1000
C Look through the DUT and compute gamma.
      Z=GAM_S11(K)+(GAM_S12(K)*GAM_S12(K)*Z)/(1-GAM_S22(K)*Z)
      ZZ=GAM_S11(K)
      PLOSS=PLOSS+1-RR(1)**2-RR(2)**2
      ZZ=GAM_S12(K)
      PLOSS=PLOSS-RR(1)**2-RR(2)**2
  110 CONTINUE
 1000 CONTINUE
      ZZ=50*(1+Z)/(1-Z)
      Z=Z_MEAS(I)
      T=RR(1)-R(1) 
      NQU=NQU+1
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      TT=DEST(NQU)**2
      T=RR(2)-R(2) 
      NQU=NQU+1
      DEST(NQU)=T-IM*ERR(NQU)
      TT=TT+DEST(NQU)**2
      SQSUM=SQSUM+DEST(NQU)**2
      TT=DSQRT(TT)
C Compute the reflection coefficient between actual source
C impedance and the optimum source impedance
      Z=(Z_OPTNF-ZZ)/(Z_OPTNF+ZZ)
      SIZE=DSQRT(R(1)**2+R(2)**2)
      T=(1+SIZE)/(1-SIZE)
      F=1/(1+SHALLOWNESS*T+SHALLOWNESS/T)
      TDB=-10*LOG10(F)-OFFSET_NF
C The LNA NF is measured NF minus the losses of the DUTs      
C Compare with the NF of the noise model.
      T=10*LOG10(1-PLOSS)+NF26(I)-TDB
      wei=1
      if(nit.gt.30)wei=25
      if(nit.gt.40)wei=100
     
      IF(NIT.GT.20.)THEN
        NQU=NQU+1
        DEST(NQU)=wei*T-IM*ERR(NQU)
        SQSUM=SQSUM+DEST(NQU)**2
      ENDIF
      IF(IP.NE.1)GOTO 100
      Z=(ZZ-50)/(ZZ+50)
      GAMMA=DSQRT(R(1)**2+R(2)**2)
      VSWR=(1+GAMMA)/(1-GAMMA)
      TL=1/(1+2*SHALLOWNESS)
      TLDB=-10*LOG10(F/TL)
      WRITE(*,627)DUT(I),z_meas(i),TT,-10*LOG10(1-PLOSS),NF26(I),
     &T,VSWR,TDB,TLDB
  627 format(a6,'(',f5.2,',',f6.2,')',f5.2,7f10.4)
  100 CONTINUE
      IF(IP.NE.1)RETURN
      WRITE(*,623)Z_OPTNF
  623 FORMAT(/,'Impedance for minimum NF = (',F5.2,','F6.2,') Ohms')
      F=1/(1+2*SHALLOWNESS)
      TDB=-10*LOG10(F)-OFFSET_NF
      WRITE(*,624)TDB, OFFSET_NF
  624 FORMAT('Optimum NF =',F8.4,' dB     (scale offset =',f8.4,')')     
      WRITE(*,625)
  625 FORMAT(/,
     &'Device   Loss          S11           S12=S21            S22')
      DO 2000 K=2,NCODES
      ZZ=GAM_S11(K)
      PLOSS=1-RR(1)**2-RR(2)**2
      ZZ=GAM_S12(K)
      PLOSS=PLOSS-RR(1)**2-RR(2)**2
      T=-10*LOG10(1-PLOSS)
      WRITE(*,630)DUTCODE(K),T,GAM_S11(K),GAM_S12(K),GAM_S22(K)
  630 FORMAT('DUT',1A,F10.4,3('  (',F6.4,',',F6.4,')'))
 2000 CONTINUE 
      RETURN      
      END
