      SUBROUTINE PDIAG
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      COMMON  /SCRATM/BTMP(NPARMX),AUX(2*NPARMX),IPIV(NPARMX)

      DATA SM15/1.E-25/
C     SMALL IS MACHINE DEPENDENT
C     SMALL IS THE SMALLEST NUMBER FOR WHICH (1+SMALL)-1 IS NOT ZERO
      DATA SMALL/.95E-12/
      SKIP=SMALL
      NDIAG=NPAR
      NORP=NDIAG+1
      NDIAGL=NDIAG-1
C
C     FIRST STEP
C     HOUSEHOLDER'S TRIDIAGONALIZATION OF THE SYMMETRIC MATRIX U.
C     AS INPUT THE LOWER TRIANGLE OF U IS USED
C     THE DIAGONAL OF THE RESULT IS STORED IN EMO AND THE SUB-DIAGONAL IN B 
C     THE TRANSFORMATION MATRICES ARE ACCUMULATED IN U
C     REFERENCE: THE PROCEDURE TRED2 BY R.S.MARTIN ET AL. 
C     NUMERISCHE MATHEMATIK 11,181-195 (1968) 
C 
C 
      DO 70 II=1,NDIAGL 
      I=NORP-II
      L=I-2 
      IMIN=I-1
      F=U(I,IMIN) 
      A=0
      IF (L.LT.1) GO TO 71
      DO 72 K=1,L 
      TT=U(I,K) 
   72 A=A+TT*TT 
   71 IF (A.GE.SM15) GO TO 73 
      BTMP(I)=F
      A=0
      GO TO 74
   73 L=L+1 
      A=A+F**2
      H=A 
      T=DSQRT(H)
      IF (F.GE.0) T=-T
      BTMP(I)=T
      A=A-F*T 
      U(I,IMIN)=F-T 
      Q=0
      DO 78 J=1,L 
      U(J,I)=U(I,J)/A 
      T=0
      DO 75 K=1,J 
   75 T=T+U(I,K)*U(J,K) 
      KK=J+1
      IF (L.LT.KK) GO TO 77 
      DO 76 K=KK,L
   76 T=T+U(I,K)*U(K,J) 
   77 BTMP(J)=T/A
   78 Q=Q+T*U(J,I)
      TT=Q/A/2. 
      DO 79 J=1,L 
      F=U(I,J)
      T=BTMP(J)-TT*F
      BTMP(J)=T
      DO 79 K=1,J 
   79 U(J,K)=U(J,K)-F*BTMP(K)-T*U(I,K)
   74 EMO(I)=A
   70 CONTINUE
      BTMP(1)=0
      EMO(1)=0
C 
C     ACCUMULATION OF TRANSFORMATION MATRICES 
C 
      DO 80 I=1,NDIAG 
      L=I-1 
      IF (DABS(EMO(I)).LT.SM15) GO TO 83
      IF (L.LT.1) GO TO 83
      DO 82 J=1,L 
      T=0
      DO 81 K=1,L 
   81 T=T+U(I,K)*U(K,J) 
      DO 82 K=1,L 
   82 U(K,J)=U(K,J)-T*U(K,I)
   83 EMO(I)=U(I,I) 
      U(I,I)=1
      IF (L.LT.1) GO TO 80
      DO 84 J=1,L 
      U(I,J)=0
   84 U(J,I)=0
   80 CONTINUE
      DO 90 I=2,NDIAG 
   90 BTMP(I-1)=BTMP(I)
      BTMP(NDIAG)=0
C     **************************************************************************
C 
C 
C     SECOND STEP 
C     THE TRIDIAGONAL MATRIX IS DIAGONALIZED USING QL TRANSFORMATIONS
C     THE DIAGONAL OF THE INPUT MATRIX IS IN EMO AND THE SUB-DIAGONAL IN B
C     THE ACCUMULATED HOUSEHOLDER TRANSFORMATIONS ARE IN U
C 
C     AS OUTPUT THE EIGENVALUES ARE STORED IN EMO AND THE EIGENVECTORS IN U 
C     REFERENCE: THE PROCEDURE TQL2 BY H.BOWDLER ET AL. 
C     NUMERISCHE MATHEMATIK 11,293-306 (1968) 
C 
C 
      T=0
      A=0
      DO 100 L=1,NDIAG
      J=0 
      CR=(DABS(EMO(L))+DABS(BTMP(L)))*SMALL
      IF (CR.GT.T) T=CR
      MA=L
      DO 101 M=L,NDIAG
      MA=M
      IF (DABS(BTMP(M)).LE.T) GO TO 102 
  101 CONTINUE
  102 IF (MA.EQ.L) GO TO 100
  103 IF (J.GE.30) GO TO 99 
      J=J+1 
      CR=(EMO(L+1)-EMO(L))/BTMP(L)/2.
      Q=DSQRT(CR**2+1)
      IF (CR.GE.0) GO TO 110
      CR=CR-Q
      GO TO 109 
  110 CR=CR+Q
  109 CONTINUE
      CR=EMO(L)-BTMP(L)/CR
      DO 104 I=L,NDIAG
  104 EMO(I)=EMO(I)-CR
      A=A+CR
      TT=EMO(MA)
      TR=1
      TS=0
      MM=MA-L 
      IF (MM.LT.1) GO TO 108
      DO 111 IT=1,MM
      I=MA-IT 
      II=I+1
      BI=BTMP(I) 
      TP=TR*BI
      H=TR*TT 
      IF (DABS(TT).GE.DABS(BI)) GO TO 105 
      TR=TT/BI
      TQ=DSQRT(TR*TR+1)
      BTMP(I+1)=TS*BI*TQ 
      TS=1/TQ
      TR=TR/TQ
      GO TO 106 
  105 TR=BI/TT
      TQ=DSQRT(TR*TR+1)
      BTMP(I+1)=TS*TT*TQ 
      TS=TR/TQ
      TR=1/TQ
  106 EMOI=EMO(I) 
      TT=TR*EMOI-TS*TP
      EMO(I+1)=H+TS*(TR*TP+TS*EMOI) 
      IF(DABS(TS).LT.SKIP) GO TO 111 
      DO 107 K=1,NDIAG
      H=U(K,II) 
      UKI=U(K,I)
      U(K,II)=TS*UKI+TR*H 
  107 U(K,I)=TR*UKI-TS*H
  111 CONTINUE
  108 BTMP(L)=TS*TT
      EMO(L)=TR*TT
      IF (DABS(BTMP(L)).GT.T) GO TO 103 
  100 EMO(L)=EMO(L)+A 
C       ******************************************************************
C     ORDER EIGENVECTORS
C 
C 
      IF (NDIAG.EQ.1) GO TO 124
      DO 120 I=1,NDIAGL
      K=I
      T=EMO(I)
      IPLUS=I+1 
      DO 121 J=IPLUS,NDIAG
      IF (EMO(J).GE.T) GO TO 121
      K=J 
      T=EMO(J)
  121 CONTINUE
      IF (K.EQ.I) GO TO 120 
      EMO(K)=EMO(I) 
      EMO(I)=T
      DO 123 J=1,NDIAG
      T=U(J,I)
      U(J,I)=U(J,K) 
  123 U(J,K)=T
  120 CONTINUE
  124 RETURN
   99 WRITE (6,699) 
      STOP
  699 FORMAT (30H ERROR: DIAGONALIZATION FAILED)
      END 
